Index: xine_input_vdr.c
===================================================================
RCS file: /cvsroot/xineliboutput/vdr-xineliboutput/xine_input_vdr.c,v
retrieving revision 1.80
diff -u -r1.80 xine_input_vdr.c
--- xine_input_vdr.c	28 Apr 2007 14:04:34 -0000	1.80
+++ xine_input_vdr.c	16 May 2007 12:07:45 -0000
@@ -883,7 +897,7 @@
 static int64_t pts_from_pes(const uint8_t *buf, int size)
 {
   int64_t pts = -1;
-  if(size>13 && buf[7] & 0x80) { /* pts avail */
+  if(size > 13 && buf[7] & 0x80) { /* pts avail */
     pts  = ((int64_t)( buf[ 9] & 0x0E)) << 29;
     pts |=  (int64_t)( buf[10]         << 22 );
     pts |=  (int64_t)((buf[11] & 0xFE) << 14 );
@@ -893,6 +907,18 @@
   return pts;
 }
 
+static void pes_strip_pts(uint8_t *buf, int size)
+{
+  if(size > 13 && buf[7] & 0x80) { /* pts avail */
+    if ((buf[6] & 0xC0) != 0x80)
+      return;
+    if ((buf[6] & 0x30) != 0)
+      return;
+    buf[7] &= ~0x80; /* clear pts flag */
+    memmove(buf+9, buf+14, size-14);
+  }
+}
+
 static void create_timeout_time(struct timespec *abstime, int timeout_ms)
 {
   struct timeval now;
@@ -4863,6 +5007,25 @@
 
   track_audio_stream_change(this, buf);
 
+#if 1
+  /* PTS wrap workaround for demuxer */
+  {
+    static int64_t last_pts = -1;
+    int64_t pts = pts_from_pes(buf->content, buf->size);
+    if(pts >= 0) {
+      int video = ( buf->content[3] >= 0xe0 && buf->content[3] <= 0xef );
+      if(video)
+        last_pts = pts;
+      if(!video) {
+        if(pts > 0x40400000 && last_pts < 0x40000000 && last_pts > 0) {
+          LOGMSG("VIDEO pts wrap before AUDIO, ignoring audio pts %" PRId64, pts);
+          pes_strip_pts(buf->content, buf->size);
+        }
+      }
+    }
+  }
+#endif
+
   /* Send current PTS ? */
   if(this->send_pts) {
     int64_t pts = pts_from_pes(buf->content, buf->size);
